/*
 * Emulator.java
 *
 * Created on January 15, 2007, 10:10 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package jace;

import jace.apple2e.Apple2e;
import jace.config.Configuration;
import jace.core.Computer;
import jace.ui.AbstractEmulatorFrame;
import jace.ui.EmulatorFrame;
import java.awt.Component;
import java.awt.EventQueue;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.JFrame;

/**
 *
 * @author Administrator
 */
public class Emulator {

    public static Emulator instance;
    public static Thread mainThread;

    public static void main(String... args) {
        mainThread = Thread.currentThread();
        instance = new Emulator(args);
    }

    public static AbstractEmulatorFrame getFrame() {
        if (instance != null) {
            return instance.theApp;
        } else {
            return null;
        }
    }
    public Apple2e computer;
    public AbstractEmulatorFrame theApp;

    /**
     * Creates a new instance of Emulator
     */
    public Emulator(String... args) {
        computer = new Apple2e();
        Configuration.loadSettings();
        Map<String, String> settings = new HashMap<String, String>();
        if (args != null) {
            for (int i = 0; i < args.length; i++) {
                if (args[i].startsWith("-")) {
                    String key = args[i].substring(1);
                    if ((i + 1) < args.length) {
                        String val = args[i + 1];
                        if (!val.startsWith("-")) {
                            settings.put(key, val);
                            i++;
                        } else {
                            settings.put(key, "true");
                        }
                    } else {
                        settings.put(key, "true");
                    }
                } else {
                    System.err.println("Did not understand parameter " + args[i] + ", skipping.");
                }
            }
        }
        Configuration.applySettings(settings);

//        theApp = new MainFrame();
        theApp = new EmulatorFrame();
        try {
            theApp.setIconImage(ImageIO.read(Emulator.class.getClassLoader().getResourceAsStream("jace/data/woz_figure.gif")));
        } catch (IOException ex) {
            Logger.getLogger(Emulator.class.getName()).log(Level.SEVERE, null, ex);
        }
        //theApp.setBounds(new Rectangle((140*6),(192*3)));
        theApp.setVisible(true);
        theApp.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        theApp.setFocusTraversalKeysEnabled(false);
        theApp.setTitle("Java Apple Computer Emulator");
        theApp.addKeyListener(computer.getKeyboard().getListener());
        theApp.addComponentListener(new ComponentListener() {
            //        theApp.screen.addComponentListener(new ComponentListener() {
            public void componentResized(ComponentEvent e) {
//                System.out.println("Screen resized");
                resizeVideo();
            }

            public void componentMoved(ComponentEvent e) {
                resizeVideo();
            }

            public void componentShown(ComponentEvent e) {
            }

            public void componentHidden(ComponentEvent e) {
            }
        });
        theApp.addWindowListener(new WindowListener() {
            public void windowOpened(WindowEvent e) {
            }

            public void windowClosing(WindowEvent e) {
            }

            public void windowClosed(WindowEvent e) {
            }

            public void windowIconified(WindowEvent e) {
                Computer.getComputer().getVideo().suspend();
            }

            public void windowDeiconified(WindowEvent e) {
                Computer.getComputer().getVideo().resume();
                resizeVideo();
            }

            public void windowActivated(WindowEvent e) {
                resizeVideo();
            }

            public void windowDeactivated(WindowEvent e) {
                resizeVideo();
            }
        });
        EmulatorUILogic.registerDebugger();
        computer.getVideo().setScreen(theApp.getScreenGraphics());
        computer.coldStart();
    }

    public static void resizeVideo() {
        AbstractEmulatorFrame window = getFrame();
        if (window != null) {
            window.resizeVideo();
        }
    }

    public static Component getScreen() {
        AbstractEmulatorFrame window = getFrame();
        if (window != null) {
            return window.getScreen();
        }
        return null;
    }
}