/*
 * IntC8SoftSwitch.java
 *
 * Created on February 1, 2007, 9:40 PM
 */
package jace.apple2e.softswitch;

import jace.apple2e.SoftSwitches;
import jace.core.Computer;
import jace.core.RAMEvent;
import jace.core.RAMListener;
import jace.core.SoftSwitch;

/**
 *
 * @author Administrator
 */
public class IntC8SoftSwitch extends SoftSwitch {

    /** Creates a new instance of IntC8SoftSwitch */
    public IntC8SoftSwitch() {
        super("InternalC8Rom", false);
        // INTC8Rom should activate whenever C3xx memory is accessed and SLOTC3ROM is off
        addListener(
                new RAMListener(RAMEvent.TYPE.ANY, RAMEvent.SCOPE.RANGE, RAMEvent.VALUE.ANY) {

                    protected void doConfig() {
                        setScopeStart(0x0C300);
                        setScopeEnd(0x0C3FF);
                    }

                    protected void doEvent(RAMEvent e) {
                        if (SoftSwitches.SLOTC3ROM.isOff()) {
                            setState(true);
                        }
                    }
                });

        // INTCXRom shoud deactivate whenever CFFF is accessed
        addListener(
                new RAMListener(RAMEvent.TYPE.ANY, RAMEvent.SCOPE.ADDRESS, RAMEvent.VALUE.ANY) {
                    protected void doConfig() {
                        setScopeStart(0x0CFFF);
                    }

                    protected void doEvent(RAMEvent e) {
                        setState(false);
                    }
                });
    }

    protected byte readSwitch() {
        return 0;
    }

    public void stateChanged() {
        Computer.getComputer().getMemory().configureActiveMemory();
    }
}