package jace.cheat;

import jace.core.Computer;
import jace.core.Device;
import jace.core.RAMListener;
import java.util.HashSet;
import java.util.Set;

/**
 * Represents some combination of hacks that can be enabled or disabled
 * through the configuration interface.
 * @author brobert
 */
public abstract class Cheats extends Device {
    Set<RAMListener> listeners = new HashSet<RAMListener>();
    
    public void addCheat(RAMListener l) {
        listeners.add(l);
        Computer.getComputer().getMemory().addListener(l);
    }

    @Override
    public void detach() {
        for (RAMListener l : listeners) {
            Computer.getComputer().getMemory().removeListener(l);
        }
        listeners.clear();
    }
    
    @Override
    public void reconfigure() {
        detach();
        attach();
    }
    
    public String getShortName() {
        return "cheat";
    }
}