package jace.config;

import jace.config.Configuration.ConfigNode;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JCheckBox;

/**
 *
 * @author brobert
 */
class BooleanComponent extends JCheckBox implements ActionListener {
    ConfigNode node;
    String fieldName;

    public BooleanComponent(ConfigNode node, String fieldName) {
        this.node = node;
        this.fieldName = fieldName;
        synchronizeValue();
        addActionListener(this);
    }

    public void actionPerformed(ActionEvent e) {
        Boolean value = Boolean.valueOf(isSelected());
        node.setFieldValue(fieldName, value);
    }

    public void synchronizeValue() {
        try {

            Object value = node.getFieldValue(fieldName);
            if (value == null) {
                setSelected(false);
            } else {
                setSelected(Boolean.valueOf(String.valueOf(value)).booleanValue());
            }
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(BooleanComponent.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}