package jace.config;

import jace.config.Configuration.ConfigNode;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.KeyEvent;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author brobert
 */
public class IntegerComponent extends StringComponent {

    @Override
    public void keyReleased(KeyEvent e) {
        String t = getText();
        if (t == null || t.equals("")) {
            try {
                ConfigurableField f = node.subject.getClass().getField(fieldName).getAnnotation(ConfigurableField.class);
                t = f.defaultValue();
                if (t == null || t.equals("")) {
                    t = "0";
                }
//                setText(t);
            } catch (NoSuchFieldException ex) {
                Logger.getLogger(IntegerComponent.class.getName()).log(Level.SEVERE, null, ex);
            } catch (SecurityException ex) {
                Logger.getLogger(IntegerComponent.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

        try {
            int i = Integer.parseInt(t);
            node.setFieldValue(fieldName, i);
            setBackground(Color.white);
        } catch (NumberFormatException ex) {
            setBackground(Color.red);
        }
    }


    public IntegerComponent(ConfigNode node, String fieldName) {
        super(node, fieldName);
        setColumns(10);
    }
}
