package jace.config;

import jace.config.Configuration.ConfigNode;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.lang.reflect.Field;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JTextField;

/**
 *
 * @author brobert
 */
class StringComponent extends JTextField implements KeyListener {
    ConfigNode node;
    String fieldName;

    public void keyTyped(KeyEvent e) {
    }

    public void keyPressed(KeyEvent e) {
    }
    
    public void keyReleased(KeyEvent e) {
        node.setFieldValue(fieldName, getText());
    }

    public StringComponent(ConfigNode node, String fieldName) {
        this.node = node;
        this.fieldName = fieldName;
        synchronizeValue();
        addKeyListener(this);
    }

    public void synchronizeValue() {
        try {
            Object value = node.getFieldValue(fieldName);
            if (value == null) {
                setText("");
            } else {
                setText(String.valueOf(value));
            }
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(StringComponent.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
