/*
 * Font.java
 *
 * Created on January 16, 2007, 8:16 PM
 *
 */

package jace.core;

import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.InputStream;
import javax.imageio.ImageIO;

/**
 *
 * @author brobert
 */
public class Font {
    static public int[][] font;
    static public int getByte(int c, int yOffset) {
        return font[c][yOffset];
    }
    static {
        font = new int[256][8];
        try {
            InputStream in = ClassLoader.getSystemResourceAsStream("jace/data/font.gif");        
            BufferedImage fontImage = ImageIO.read(in);
            for (int i=0; i < 256; i++) {
                int x = (i >> 4)*13 + 2;
                int y = (i & 15)*13 + 4;
                for (int j=0; j < 8; j++) {
                    int row = 0;
                    for (int k=0; k < 7; k++) {
                        int color = fontImage.getRGB((7-k)+x, j+y);
                        row = (row<<1) | (1-(color&1));
//                        row = (row<<1) | (color&1);
                    }
                    font[i][j]=row;
                }
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    
    /** Creates a new instance of Font */
    private Font() {
    }
    
}
