package jace.core;

/**
 *
 * @author blurry
 */
public class RAMEvent {
    public enum TYPE {
        READ(true),
        READ_DATA(true),
        EXECUTE(true),
        READ_OPERAND(true),
        WRITE(false),
        ANY(false);
        boolean read=false;
        TYPE(boolean r) {
            this.read = r;
        }
        public boolean isRead() {return read;}
    };

    public enum SCOPE {
        ADDRESS,
        RANGE,
        ANY
    };

    public enum VALUE {
        ANY,
        RANGE,
        EQUALS,
        NOT_EQUALS,
        CHANGE_BY
    };
    
    private TYPE type;
    private SCOPE scope;
    private VALUE value;
    private int address, oldValue, newValue;
    /** Creates a new instance of RAMEvent */
    public RAMEvent(TYPE t, SCOPE s, VALUE v, int address, int oldValue, int newValue) {
        setType(t);
        setScope(s);
        setValue(v);
        this.setAddress(address);
        this.setOldValue(oldValue);
        this.setNewValue(newValue);
    }

    public TYPE getType() {
        return type;
    }

    public void setType(TYPE type) {
        this.type = type;
    }

    public SCOPE getScope() {
        return scope;
    }

    public void setScope(SCOPE scope) {
        this.scope = scope;
    }

    public VALUE getValue() {
        return value;
    }

    public void setValue(VALUE value) {
        this.value = value;
    }

    public int getAddress() {
        return address;
    }

    public void setAddress(int address) {
        this.address = address;
    }

    public int getOldValue() {
        return oldValue;
    }

    public void setOldValue(int oldValue) {
        this.oldValue = oldValue;
    }

    public int getNewValue() {
        return newValue;
    }

    public void setNewValue(int newValue) {
        this.newValue = newValue;
    }
    
}
