package jace.hardware.massStorage;

import java.io.IOException;

/**
 *
 * @author brobert
 */
public class FreespaceBitmap extends DiskNode {
    int size = (ProdosVirtualDisk.MAX_BLOCK + 1) / 8 / ProdosVirtualDisk.BLOCK_SIZE;
    public FreespaceBitmap(ProdosVirtualDisk fs, int start) throws IOException {
        setBaseBlock(start);
        setOwnerFilesystem(fs);

        for (int i=1; i < size; i++) {
            new SubNode(i, this, start+i);
        }
    }
    @Override
    public void doDeallocate() {
//
    }

    @Override
    public void doAllocate() {
///
    }

    @Override
    public void doRefresh() {
//
    }

    @Override
    public void readBlock(int sequence, byte[] buffer) throws IOException {
        int startBlock = sequence * ProdosVirtualDisk.BLOCK_SIZE * 8;
        int endBlock = (sequence+1)* ProdosVirtualDisk.BLOCK_SIZE * 8;
        int bitCounter=0;
        int pos=0;
        int value=0;
        for (int i=startBlock; i < endBlock; i++) {
            if (!getOwnerFilesystem().isAllocated(i)) {
                value++;
            }
            bitCounter++;
            if (bitCounter < 8) {
                value *= 2;
            } else {
                bitCounter = 0;
                buffer[pos++]=(byte) value;
                value = 0;
            }
        }
    }
}