/*
 * EnvelopeGenerator.java
 *
 * Created on April 18, 2006, 5:49 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package jace.hardware.mockingboard;

public class EnvelopeGenerator extends TimedGenerator {
    boolean hold = false;
    boolean attk = false;
    boolean alt  = false;
    boolean cont = false;
    int direction;
    int amplitude;
    public EnvelopeGenerator(int _clock,int _sampleRate) {
        super(_clock, _sampleRate);
    }
    public int stepsPerCycle() {
        return 8;
    }

    @Override
    public void setPeriod(int p) {
        if (p > 0)
            super.setPeriod(p);
        else
            clocksPerPeriod = stepsPerCycle() / 2;
    }
    
    
    public void step() {
        int stateChanges = updateCounter();
        for (int i=0; i < stateChanges; i++) {
            if (amplitude == 0 && direction == -1) {
                if (!cont) {
                    direction = 0;
                } else if (hold) {
                    direction = 0;
                    if (alt) amplitude = 15;
                } else if (alt) {
                    direction = 1;
                } else {
                    amplitude = 15;
                }
            }
            if (amplitude == 15 && direction == 1) {
                if (!cont) {
                    direction = 0;
                    amplitude = 0;
                } else if (hold) {
                    direction = 0;
                    if (alt) amplitude = 0;
                } else if (alt) {
                    direction = -1;
                } else {
                    amplitude = 0;
                }
            }
            amplitude += direction;
        }
    }
    public void setShape(int shape) {
        counter = 0;        
        cont = (shape & 8) != 0;
        attk = (shape & 4) != 0;
        alt  = (shape & 2) != 0;
        hold = (shape & 1) != 0;
        if (attk) {
            amplitude = 0;
            direction = 1;
        } else {
            amplitude = 15;
            direction = -1;
        }
    }
    public int getAmplitude() {
        return amplitude;
    }
    public void reset() {
        super.reset();
        setShape(0);
    }
}