/*
 * SoundGenerator.java
 *
 * Created on April 18, 2006, 5:48 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package jace.hardware.mockingboard;

import jace.hardware.CardMockingboard;

public class SoundGenerator extends TimedGenerator {
    int amplitude;
    boolean useEnvGen;
    boolean active;
    boolean noiseActive;
    boolean inverted;
    public SoundGenerator(int _clock, int _sampleRate) {
        super(_clock, _sampleRate);
    }
    
    @Override
    public int stepsPerCycle() {
        return 8;
    }
    public void setAmplitude(int _amp) {
        amplitude = (_amp & 0x0F);
        useEnvGen = (_amp & 0x010) != 0;
    }
    public void setActive(boolean _active) {
        active = _active;
    }
    public void setNoiseActive(boolean _active) {
        noiseActive = _active;
    }

    @Override
    public void setPeriod(int _period) {
        super.setPeriod(_period);
    }
    
    public int step(NoiseGenerator noiseGen, EnvelopeGenerator envGen) {
        int stateChanges = updateCounter();
        if (((stateChanges & 1) == 1)) inverted = !inverted;
        if (amplitude == 0 && !useEnvGen) return 0;
        if (!active && !noiseActive) return 0;
        boolean invert = false;
        int vol = useEnvGen ? envGen.getAmplitude() : amplitude;
        if (active) {
            invert = noiseActive && noiseGen.isOn() ? false : inverted;
        } else {
            invert = noiseActive && !noiseGen.isOn();
        }
        return invert ? -CardMockingboard.VolTable[vol] : CardMockingboard.VolTable[vol];
    }
    
    public void reset() {
        super.reset();
        amplitude = 0;
        useEnvGen = false;
        active = false;
        noiseActive = false;
        inverted = false;
    }
};