/*
 * TimedGenerator.java
 *
 * Created on April 18, 2006, 5:47 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package jace.hardware.mockingboard;

public class TimedGenerator {
    int sampleRate;
    int clock;
    // Default period to 1 so that this can be used as a regular interval timer right away
    int period = 1;
    public double counter;
    double cyclesPerSample;
    int clocksPerPeriod;
    private TimedGenerator() {}
    public TimedGenerator(int _clock, int _sampleRate) {
        setRate(clock, sampleRate);
        reset();
    }
    // In most cases a cycle is a step.  The AY uses 16-cycle based periods for its oscillators
    // Basically this works as a hard-coded multiplier if overridden.
    public int stepsPerCycle() {return 1;}
    
    public void setRate(int clock, int sample_rate) {
        sampleRate = sample_rate;
        this.clock = clock;
        cyclesPerSample = ((double) clock) / ((double) sampleRate);
    }
    public void setPeriod(int _period) {
        period = _period > 0 ? _period : 1;
        clocksPerPeriod = (int) (period * stepsPerCycle());
        // set counter back... necessary?
//        while (clocksPerPeriod > period) {
//            counter -= clocksPerPeriod;
//        }
    }
    protected int updateCounter() {        
        counter += cyclesPerSample;
        int numStateChanges = 0;
        while (counter >= clocksPerPeriod) {
            counter -= clocksPerPeriod;
            numStateChanges++;
        }
        return numStateChanges;
    }
    public void reset() {
        counter = 0;
        period = 1;
    }
};