package jace.tracker;

import javax.sound.sampled.LineUnavailableException;
import jace.hardware.CardMockingboard;
import jace.hardware.mockingboard.PSG;

/**
 *
 * @author blurry
 */
public class PlaybackTest {
    PlaybackEngine engine;
    CardMockingboard card;
    PSG chip;
    
    /** Creates a new instance of PlaybackTest */
    public PlaybackTest() {
        card = new CardMockingboard();
        card.phasorMode = false;
        card.reconfigure();
        engine = new PlaybackEngine(card);
    }
    
    public static void main(String[] args) {
        PlaybackTest test = new PlaybackTest();
        test.go();
    }
    
    public void go() {
        card.chips[0].writeReg(PSG.Reg.Enable, 0x00fe);
        card.chips[0].writeReg(PSG.Reg.AVol, 0x0f);
        card.chips[0].writeReg(PSG.Reg.ACoarse, 0x00);
//        card.chips[0].writeReg(PSG.Reg.AFine, 0x00fe);
        card.chips[0].writeReg(PSG.Reg.AFine, 0x007f);
        try {
            engine.startPlayback();            
        card.chips[1].writeReg(PSG.Reg.Enable, 0x00fe);
        card.chips[1].writeReg(PSG.Reg.AVol, 0x0c);
        card.chips[1].writeReg(PSG.Reg.ACoarse, 0x00);
        card.chips[1].writeReg(PSG.Reg.AFine, 0x00fe);
            Thread.sleep(2000);
        card.chips[0].writeReg(PSG.Reg.AVol, 0x10);
        card.chips[0].writeReg(PSG.Reg.EnvShape, 0x0A);
        card.chips[0].writeReg(PSG.Reg.EnvCoarse, 0x02);
        card.chips[0].writeReg(PSG.Reg.EnvFine, 0x00);
            Thread.sleep(2000);
        } catch (LineUnavailableException ex) {
            ex.printStackTrace();
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
        engine.stopPlayback();
    }
}
